#ifndef	TWINSTAR_ASTRIBANKS_H
#define	TWINSTAR_ASTRIBANKS_H

#include <glib-object.h>

G_BEGIN_DECLS

#define TWINSTAR_TYPE_ASTRIBANKS         (twinstar_astribanks_get_type ())
#define TWINSTAR_ASTRIBANKS(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TWINSTAR_TYPE_ASTRIBANKS, TwinstarAstribanks))
#define TWINSTAR_ASTRIBANKS_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TWINSTAR_TYPE_ASTRIBANKS, TwinstarAstribanksClass))
#define TWINSTAR_IS_ASTRIBANKS(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TWINSTAR_TYPE_ASTRIBANKS))
#define TWINSTAR_IS_ASTRIBANKS_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TWINSTAR_TYPE_ASTRIBANKS))
#define TWINSTAR_ASTRIBANKS_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TWINSTAR_TYPE_ASTRIBANKS, TwinstarAstribanksClass))

typedef struct TwinstarAstribanksPrivate TwinstarAstribanksPrivate;

typedef struct {
	GObject parent;
	TwinstarAstribanksPrivate *priv;
} TwinstarAstribanks;

typedef struct {
	GObjectClass             parent_class;
} TwinstarAstribanksClass;

typedef enum {
	TWINSTAR_ASTRIBANKS_ERROR_GENERAL,
	TWINSTAR_ASTRIBANKS_NUM_ERRORS
} TwinstarAstribanksError;


#define	TWINSTAR_ASTRIBANKS_ERROR		(twinstar_astribanks_error_quark ())
#define	TWINSTAR_ASTRIBANKS_TYPE_ERROR		(twinstar_astribanks_error_get_type ())

GQuark	twinstar_astribanks_error_quark		(void);
GType	twinstar_astribanks_error_get_type	(void);


struct astribank_info {
	char location[40];
	char hardware_id[40];
};

struct twinstar_astribank_notify_ops {
	int (*astribank_notify)(int count, const struct astribank_info *ab, int added, const char *devpath, void *context);
	int (*astribank_count)(int count, void *context);
};

TwinstarAstribanks *twinstar_astribanks_new(struct twinstar_astribank_notify_ops *notify_ops, void *context);
void twinstar_astribanks_destroy(TwinstarAstribanks *twab);
int twinstar_astribanks_inventory(TwinstarAstribanks *twab, struct astribank_info **abinfo);
void twinstar_astribanks_inventory_free(TwinstarAstribanks *twab, struct astribank_info *abinfo);
int twinstar_astribank_count(TwinstarAstribanks *twab);
void twinstar_astribank_event(TwinstarAstribanks *twab, int added, const char *devpath);
void read_astribank_info(const char *devpath, struct astribank_info *ai);

G_END_DECLS

#endif	/* TWINSTAR_ASTRIBANKS_H */
